// cVector.hpp

class cVector;

#import "math3d.h"


class cVector {
  public:
  VECTOR            mV; // we only realy care about X, Y and Z
  public:
                    cVector();
  BOOLEAN           Equal(cVector v);
  BOOLEAN           Unequal(cVector v);
  void              Set(SCALAR x, SCALAR y, SCALAR z, SCALAR w);
  void              Set(SCALAR x, SCALAR y, SCALAR z);
  void              Set(cVector p0, cVector p1);
  INTEG             Perspective(SCALAR xzoom, SCALAR yzoom);
  void              Polar();
  void              Normalise();
  SCALAR            Len();
  SCALAR            Dot(cVector v);
  void              Crs(cVector v);
  void              Add(cVector v);
  void              Sub(cVector v);
  void              Mul(SCALAR s);
  void              Div(SCALAR s);
  void              Neg();
  ANGLE             XZangle();
  ANGLE             XYangle();
  ANGLE             YZangle();
  INTEG             Nearest(cVector *vList, INTEG n);
  INTEG             Furthest(cVector *vList, INTEG n);
  void              CenterOf(cVector *vList, INTEG n);
  INTEG             FindInList(cVector *vList, INTEG n);
  BOOLEAN           InPolygon(INTEG n, cVector *vtx);
  cVector           GetUV(INTEG n, cVector *vtx, cVector *tex);
  void              Print(FILE *f);
};


