// cBuilding.cpp

#include "cBuilding.h"

#include "cConstructModel.h"


cBuilding::cBuilding(float* pos, float* rot)
{
  mRoles |= (1UL << cObject::BUILDING);
  if (pos != NULL) memcpy(mPos, pos, sizeof(float) * 3);
  if (rot != NULL) memcpy(mRot, rot, sizeof(float) * 3);
  
  mModel = NULL; // Deprecated: See header.
}


void cBuilding::onSpawn()
{
  // Find Model-Object.
  mModel = new cConstructModel((char*) "data/objects/build0.txt");
  // Register position and rotation vector for Model-Object.
  mModel->setRotator(this->mRot);
  mModel->setTranslator(this->mPos);
}


void cBuilding::transformSelf()
{
    if (mModel) mModel->transformSelf();
}


void cBuilding::drawSolid()
{
    if (mModel) mModel->drawSelf();
};

