// cObject.hpp

#include "cObject.h"

#define set3f(v, x,y,z) { (v)[0] = x; (v)[1] = y; (v)[2] = z; }

#define cpy3f(vdest, vsrc) memcpy(vdest, vsrc, sizeof(float)*3)

cObject::cObject()
{
  //printf("cObject::cObject()\n");
    
  // BASE
  mWorld = NULL;
  mFragged = false;
  mRoles = 0;

  // NAMEABLE
  mName = new string("Anonymous");
  mDescription = new string("Undescribed");
  mDesignation = 0;
  
  // SOCIAL
  mAllies = 0;
  mEnemies = 0;
  
  // TRACKABLE
  set3f(mPos, 0.0f, 0.0f, 0.0f);
  set3f(mRot, 0.0f, 0.0f, 0.0f);
  mRadius = 1;
  
  // DAMAGEABLE
  mHp = 100.0f;
  //mSplasharmor = NULL;
  //mBeamarmor = NULL;
  //mPiercearmor = NULL;
  
  // ENTITY
  mTarget = NULL;
  set3f(mDestination, 0.0f, 0.0f, 0.0f);
  mPad = NULL;
  mController = NULL;
}


cObject::cObject(cObject* source)
{
  //printf("cObject::cObject(cObject*)\n");

  // BASE
  mWorld = NULL;
  mFragged = source->mFragged;
  mRoles = source->mRoles;
  
  // NAMEABLE
  mName = source->mName;
  mDesignation = source->mDesignation;
  
  // SOCIAL
  mAllies = source->mAllies;
  mEnemies = source->mEnemies;
  
  // TRACKABLE
  cpy3f(mPos, source->mPos);
  cpy3f(mRot, source->mPos);
  mRadius = source->mRadius;
  
  // DAMAGEABLE
  mHp = source->mHp;
  //mSplasharmor = source->mSplasharmor;
  //mBeamarmor = source->mBeamarmor;
  //mPiercearmor = source->mPiercearmor;
  
  // ENTITY
  mTarget = source->mTarget;
  cpy3f(mDestination, source->mDestination);
  mPad = source->mPad;
  mController = source->mController;
}


